//
// Created by webpigeon on 17/04/22.
//

#ifndef FGGL_GFX_OGL4_CANVAS_HPP
#define FGGL_GFX_OGL4_CANVAS_HPP

#include "fggl/gfx/paint.hpp"
#include "fggl/gfx/ogl/types.hpp"
#include "fggl/gfx/windowing.hpp"

#include "fggl/gui/fonts.hpp"

namespace fggl::gfx::ogl4 {

	class CanvasRenderer {
		public:
			CanvasRenderer();
			void render(GLuint shader, const gfx::Paint& paint);

			inline gfx::Bounds bounds() const {
				return m_bounds;
			}

		private:
			gfx::Bounds m_bounds;
			ogl::VertexArray m_vao;
			ogl::ArrayBuffer m_vertexList;
			ogl::ElementBuffer m_indexList;
			gui::FontLibrary m_fonts;
			ogl::Texture m_fontTex;

			void renderShapes(const Paint &paint, GLuint shader);
			void renderText(const Paint&, GLuint shader);
	};

} // namespace fggl::gfx::ogl4

#endif //FGGL_GFX_OGL4_CANVAS_HPP
