#ifndef FGGL_GFX_VK_CORE_H
#define FGGL_GFX_VK_CORE_H

#include <memory>

#include <fggl/app.hpp>

#include <vulkan/vulkan.hpp>
#include <vulkan/vulkan_raii.hpp>

namespace fggl::gfx::vkgfx {

	constexpr char const *EngineName = "FGGL";

	class VulkanGraphics {

		private:
			vk::raii::Instance m_instance;
			std::unique_ptr<vk::raii::SwapchainKHR> m_swapchain;
	};

	class VulkanContext {
		public:
			VulkanContext();

			VulkanGraphics &createGraphics();

		private:
			vk::raii::Context m_context;
	};

}

#endif
