/*
 * ${license.title}
 * Copyright (C) 2022 ${license.owner}
 * ${license.mailto}
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

//
// Created by webpigeon on 23/04/22.
//

#ifndef FGGL_SCENES_GAME_HPP
#define FGGL_SCENES_GAME_HPP

#include "fggl/app.hpp"

namespace fggl::scenes {

	class Game : public fggl::AppState {

		public:
			explicit Game(fggl::App& app);

			void activate() override;
			void deactivate() override;

			void update() override;
			void render(fggl::gfx::Graphics& gfx) override;

		protected:
			inline auto world() -> ecs3::World& {
				return *m_world;
			}

			inline auto input() -> input::Input& {
				return *m_input;
			}

		private:
			std::shared_ptr<input::Input> m_input;
			std::unique_ptr<ecs3::World> m_world;
			std::string m_previous = "menu";
	};

} // namespace fggl::scenes

#endif //FGGL_SCENES_GAME_HPP
