#ifndef FGGL_UTIL_CHRONO_H
#define FGGL_UTIL_CHRONO_H

namespace fggl::util {

	class Timer {
			using time_t = unsigned long;
		public:
			inline void frequency(float freq) {
				m_freq = freq;
			}

			inline void setup(time_t epoch) {
				m_first = epoch;
				m_last = m_first;
				m_curr = m_first;
			}

			inline void tick(time_t time) {
				m_last = m_curr;
				m_curr = time;
			}

			[[nodiscard]]
			inline float delta() const {
				return (m_curr - m_last) / m_freq;
			}

		private:
			float m_freq;
			time_t m_first;
			time_t m_last;
			time_t m_curr;
	};
};

#endif
